//----------------------------------------------------------------------------

//RT-9510S CPU
//  , header file

//----------------------------------------------------------------------------

#ifndef KeyboardH
#define KeyboardH

//----------------------------- : -----------------------------------

//  :

#define KEY_CH1    0x0001 //S0-R0: CH-1, NOP, NOP
#define KEY_CH2    0x0002 //S0-R1: CH-2, HOUR UP, HOUR UP
#define KEY_CH3    0x0004 //S0-R2: CH-3, 10 MIN UP, 10 MIN UP
#define KEY_TUP    0x0008 //S0-R3: TUNING UP

#define KEY_CH4    0x0010 //S1-R0: CH-4, 1 MIN UP, 1 MIN UP
#define KEY_CH5    0x0020 //S1-R1: CH-5, NOP, TIMER CLEAR
#define KEY_CH6    0x0040 //S1-R2: CH-6, 0 SEC ADJ, TIMER 1-2
#define KEY_TDN    0x0080 //S1-R3: TUNING DOWN

#define KEY_MEM    0x0100 //S2-R0: MEMORY, NOP, MEMORY CH UP
#define KEY_DIS    0x0200 //S2-R1: DISPLAY RADIO-CLOCK
#define KEY_AT     0x0400 //S2-R2: AUTO TUNE, NOP, WEEK
#define KEY_S2R3   0x0800 //S2-R3:

#define KEY_ADJ    0x1000 //S3-R0: ADJUST
#define KEY_T_C    0x2000 //S3-R1: TIMER-CLOCK
#define KEY_FAST   0x4000 //S3-R2: FAST
#define KEY_SW2  0x008000 //S3-R3: SW2 band

#define KEY_LW   0x010000 //S4-R0: MW band
#define KEY_MW   0x020000 //S4-R1: LW band
#define KEY_FM   0x040000 //S4-R2: FM band
#define KEY_SW1  0x080000 //S4-R3: SW1 band

//  (     ):

#define DET_SW2      0x01 //S3-R3: SW2 band
#define DET_LW       0x02 //S4-R0: MW band
#define DET_MW       0x04 //S4-R1: LW band
#define DET_FM       0x08 //S4-R2: FM band
#define DET_SW1      0x10 //S4-R3: SW1 band

//-:
#define KEY_MOD (KEY_ADJ | KEY_FAST)
//  :
#define KEY_REP (KEY_CH2 | KEY_CH3 | KEY_TUP | KEY_CH4 | KEY_TDN | KEY_AT)
// :
#define REP 0x8000

//--------------------------  : ------------------------------

void Keyboard_Init(void);         //  
void Keyboard_Exe(bool t);        // 
char Keyboard_GetBand(void);      // 
int  Keyboard_GetCode(void);      //  

//----------------------------------------------------------------------------

#endif

