//----------------------------------------------------------------------------

//RT-9510S CPU
// ,  

//----------------------------------------------------------------------------

#ifndef MainH
#define MainH

//----------------------------------------------------------------------------

#include <iom88.h>
#include <intrinsics.h>
#include <stdbool.h>

//----------------------------- : -----------------------------------

#define	F_CLK     8.000 // , 
#define T_SYS    1000.0 // , 
#define DIV_SYS      64 //  

//-------------------------  : ---------------------------------

//I - 
//O - 
//B -  

//L -   
//H -   
//X -    
//A -  

//-------------------------------  B: ------------------------------------

#define MUTE   (1 << PB0) //OH -   MUTE  
#define AS     (1 << PB1) //IH -   
#define NC_PB2 (1 << PB2) //OL -   (SPI SS)
#define SDO    (1 << PB3) //OH -    (SPI MOSI)
#define SDI    (1 << PB4) //IH -    (SPI MISO)
#define SCK    (1 << PB5) //OH -   (SPI SCK)
#define SCAN0  (1 << PB6) //OH -  0  
#define SCAN1  (1 << PB7) //OH -  1  

//:
#define I_DDRB  (MUTE | NC_PB2 | SDO | SCK | SCAN0 | SCAN1)
//  (in)    (out):
#define I_PORTB (MUTE | SDO | SCK)
//    :
#define Port_MUTE_0   (PORTB &= ~MUTE)
#define Port_MUTE_1   (PORTB |= MUTE)
#define Pin_AS        (PINB & AS)
#define Port_SCAN0_0  (PORTB &= ~SCAN0)
#define Port_SCAN0_1  (PORTB |= SCAN0)
#define Port_SCAN1_0  (PORTB &= ~SCAN1)
#define Port_SCAN1_1  (PORTB |= SCAN1)

//-------------------------------  C: ------------------------------------

#define RET0   (1 << PC0) //IH -  0  
#define RET1   (1 << PC1) //IH -  1  
#define RET2   (1 << PC2) //IH -  2  
#define RET3   (1 << PC3) //IH -  3  
#define PLLA   (1 << PC4) //OH -    A
#define PLLB   (1 << PC5) //OH -    B

//:
#define I_DDRC  (PLLA | PLLB)
//  (in)    (out):
#define I_PORTC (0x00)
//    :
#define Pin_RET0      (PINC & RET0)
#define Pin_RET1      (PINC & RET1)
#define Pin_RET2      (PINC & RET2)
#define Pin_RET3      (PINC & RET3)
#define Port_PLLA_0   (PORTC &= ~PLLA)
#define Port_PLLA_1   (PORTC |= PLLA)
#define Port_PLLB_0   (PORTC &= ~PLLB)
#define Port_PLLB_1   (PORTC |= PLLB)

//-------------------------------  D: ------------------------------------

#define PLLC   (1 << PD0) //OH -    C
#define PLLD   (1 << PD1) //OH -    D
#define ON     (1 << PD2) //IH -   
#define NC_PD3 (1 << PD3) //OL -  
#define LOAD   (1 << PD4) //OH -    LOAD
#define SCAN2  (1 << PD5) //OH -  2  
#define SCAN3  (1 << PD6) //OH -  3  
#define SCAN4  (1 << PD7) //OH -  4  

//:
#define I_DDRD  (PLLC | PLLD | NC_PD3 | LOAD | SCAN2 | SCAN3 | SCAN4)
//  (in)    (out):
#define I_PORTD (0x00)
//    :
#define Port_PLLC_0   (PORTD &= ~PLLC)
#define Port_PLLC_1   (PORTD |= PLLC)
#define Port_PLLD_0   (PORTD &= ~PLLD)
#define Port_PLLD_1   (PORTD |= PLLD)
#define Pin_ON        (PIND & ON)
#define Port_LOAD_0   (PORTD &= ~LOAD)
#define Port_LOAD_1   (PORTD |= LOAD)
#define Port_SCAN2_0  (PORTD &= ~SCAN2)
#define Port_SCAN2_1  (PORTD |= SCAN2)
#define Port_SCAN3_0  (PORTD &= ~SCAN3)
#define Port_SCAN3_1  (PORTD |= SCAN3)
#define Port_SCAN4_0  (PORTD &= ~SCAN4)
#define Port_SCAN4_1  (PORTD |= SCAN4)

//-------------------------- : -------------------------------

#define LO(x)    ((char)((x) & 0xFF))
#define HI(x)    ((char)(((x) >> 8) & 0xFF))
#define BYTE1(x) (LO(x))
#define BYTE2(x) (HI(x))
#define BYTE3(x) ((char)(((unsigned long)(x) >> 16) & 0xFF))
#define BYTE4(x) ((char)(((unsigned long)(x) >> 24) & 0xFF))

#define WORD(b1,b0)        (((unsigned int)(b1) << 8) | (b0))
#define DWORD(b3,b2,b1,b0) (((unsigned long)WORD(b3,b2) << 16) | WORD(b1,b0))

#define ABS(x) (((x) < 0)? -(x) : (x))

#define Delay_us(x) __delay_cycles((unsigned int)((x) * F_CLK + 0.5))
#define ms2sys(x) ((unsigned int)(1E3 * (x) / T_SYS))
#define s2sys(x) ((unsigned long)(1E6 * (x) / T_SYS))

//----------------------------------------------------------------------------

#endif
