//----------------------------------------------------------------------------

//RT-9510S CPU
//   SPI

//----------------------------------------------------------------------------

#include "Main.h"
#include "Port.h"

//-------------------------  : ----------------------------

void Port_Init(void)
{
  //SPI enable, LSB first, Master, CLK pol. pos., CLK phase fall, CLK/128:
  SPCR = (1<<SPE) | (1<<DORD) | (1<<MSTR) | (1<<CPOL) | (1<<CPHA) |
         (1<<SPR1) | (1<<SPR0);
}

//----------------------------  : -------------------------------

char Port_Rx(void)
{
  SPDR = 0xFF;
  while(!(SPSR & (1<<SPIF)));
  return(SPDR);
}

//---------------------------  : ------------------------------

void Port_Tx(char cmd)
{
  SPDR = cmd;
  while(!(SPSR & (1<<SPIF)));
}

//------------------    LCD_ShowRadio: ----------------------

void Port_TxRadio(char b, int f, char ch)
{
  SPDR = CMD_SHOW_RADIO;
  while(!(SPSR & (1<<SPIF)));
  SPDR = b;
  while(!(SPSR & (1<<SPIF)));
  SPDR = HI(f);
  while(!(SPSR & (1<<SPIF)));
  SPDR = LO(f);
  while(!(SPSR & (1<<SPIF)));
  SPDR = ch;
  while(!(SPSR & (1<<SPIF)));
}

//----------------------------------------------------------------------------
