//----------------------------------------------------------------------------

//RT-9510S LCD
// ,  

//----------------------------------------------------------------------------

#ifndef MainH
#define MainH

//----------------------------------------------------------------------------

#include <iom329.h>
#include <intrinsics.h>
#include <stdbool.h>

//----------------------------- : -----------------------------------

#define	F_CLK    8.000 // , 

//-------------------------  : ---------------------------------

//I - 
//O - 
//B -  

//L -   
//H -   
//X -    
//A -  

//-------------------------------  A: ------------------------------------

#define NC_PA3 (1 << PA3) //OL -  

//   A    LCD

//:
#define I_DDRA  (NC_PA3)
//  (in)    (out):
#define I_PORTA (0x00)

//-------------------------------  B: ------------------------------------

#define SS     (1 << PB0) //IL -  SS SPI
#define SCK    (1 << PB1) //IH -  CLK SPI
#define MOSI   (1 << PB2) //IH -  MOSI (SDI) SPI
#define MISO   (1 << PB3) //OH -  MISO (SDO) SPI
#define TMROUT (1 << PB4) //OH -  TIMER OUT
#define POWON  (1 << PB5) //IH -  POWER ON
#define TMRSTB (1 << PB6) //OH -  TMR-STB ( SOUT)
#define SLEEP  (1 << PB7) //IH -   SLEEP

//:
#define I_DDRB  (MISO | TMROUT | TMRSTB)
//  (in)    (out):
#define I_PORTB (SCK | MOSI)
//    :
#define Pin_SCK       (PINB & SCK)
#define Pin_MOSI      (PINB & MOSI)
#define Port_TMROUT_0 (PORTB &= ~TMROUT)
#define Port_TMROUT_1 (PORTB |= TMROUT)
#define Pin_POWON     (PINB & POWON)
#define Port_TMRSTB_0 (PORTB &= ~TMRSTB)
#define Port_TMRSTB_1 (PORTB |= TMRSTB)
#define Pin_SLEEP     (PINB & SLEEP)

//-------------------------------  C: ------------------------------------

//   C    LCD

//:
#define I_DDRC  (0x00)
//  (in)    (out):
#define I_PORTC (0x00)

//-------------------------------  D: ------------------------------------

//   G    LCD

//:
#define I_DDRD  (0x00)
//  (in)    (out):
#define I_PORTD (0x00)

//-------------------------------  E: ------------------------------------

#define SPI_SS (1 << PE7) //OH -   SS SPI

//   E  

//:
#define I_DDRE  (0xFF)
//  (in)    (out):
#define I_PORTE (SPI_SS)
//    :
#define Port_SPI_SS_0 (PORTE &= ~SPI_SS)
#define Port_SPI_SS_1 (PORTE |= SPI_SS)

//-------------------------------  F: ------------------------------------

//  F  

//:
#define I_DDRF  (0xFF)
//  (in)    (out):
#define I_PORTF (0x00)

//-------------------------------  G: ------------------------------------

#define NC_PG3 (1 << PG3) //OL -  

//   G    LCD

//:
#define I_DDRG  (NC_PG3)
//  (in)    (out):
#define I_PORTG (0x00)

//-------------------------- : -------------------------------

#define LO(x)    ((char)((x) & 0xFF))
#define HI(x)    ((char)(((x) >> 8) & 0xFF))
#define BYTE1(x) (LO(x))
#define BYTE2(x) (HI(x))
#define BYTE3(x) ((char)(((unsigned long)(x) >> 16) & 0xFF))
#define BYTE4(x) ((char)(((unsigned long)(x) >> 24) & 0xFF))

#define WORD(b1,b0)        (((unsigned int)(b1) << 8) | (b0))
#define DWORD(b3,b2,b1,b0) (((unsigned long)WORD(b3,b2) << 16) | WORD(b1,b0))

#define ABS(x) (((x) < 0)? -(x) : (x))

#define Delay_us(x) __delay_cycles((unsigned int)((x) * F_CLK + 0.5))
#define ms2sys(x) ((unsigned int)(1E3 * (x) / T_SYS))
#define s2sys(x) ((unsigned long)(1E6 * (x) / T_SYS))

//--------------------------  : ------------------------------

void Main_PowerOn(char ch); //
void Main_OffEn(void);      // 
void Main_PowerOff(void);   //
bool Main_PowerState(void); // 

//----------------------------------------------------------------------------

#endif
