//----------------------------------------------------------------------------

//RT-9510S LCD
//  SPI-

//----------------------------------------------------------------------------

//       SPI   slave.
//         .
//    , ,  
//   ( ).

//WARNING!        
//    .    , 
//    ,     .  ,
//   .    
//   .

//----------------------------------------------------------------------------

#include "Main.h"
#include "Port.h"
#include "RTC.h"

//----------------------------- : ----------------------------------

static char Data[4]; // 
static char Ptr;     // 

//-----------------------  SPI-: ---------------------------

void Port_Init(void)
{
  Port_SPI_SS_1;
  //SPI enable, Slave, LSB first, SCK pol. neg. (  
  //), SCK phase fall:
  SPCR = (1<<SPE) | (1<<DORD) | (1<<CPHA);
  Ptr = 0;
}

//----------------------------------------------------------------------------

void Port_Exe(void)
{
  if(SPSR & (1<<SPIF))
  {
    char d = SPDR;
    SPDR = 0;
    if(Ptr == 0)
    {
      switch(d)
      {
      //   :
      case CMD_SHOW_CLOCK:  RTC_ShowClock();  break;
      case CMD_SHOW_TIMER1: RTC_ShowTimer1(); break;
      case CMD_SHOW_TIMER2: RTC_ShowTimer2(); break;
      //     :
      case CMD_INC_HRS:     RTC_IncHrs();     break;
      case CMD_INC_10M:     RTC_Inc10m();     break;
      case CMD_INC_MIN:     RTC_IncMin();     break;
      case CMD_ADJ_SEC:     RTC_AdjSec();     break;
      case CMD_INC_WEEK:    RTC_IncWeek();    break;
      case CMD_INC_CHAN:    RTC_IncChan();    break;
      case CMD_CH0:         RTC_Ch0();        break;
      //    :
      case CMD_SHOW_RADIO:  Ptr = 4;          break;
      }
    }
    else
    {
      //     :
      Data[--Ptr] = d;
      if(Ptr == 0)
      {
        RTC_ShowRadio(Data[3], WORD(Data[2], Data[1]), Data[0]);
      }
    }
  }
}

//----------------------------------------------------------------------------
